import ktc
import numpy as np
import os
from os import walk
import onnx
from PIL import Image


# Load the exported onnx model as an onnx object
exported_m = onnx.load('/workspace/last.onnx')
# Optimize the exported onnx object
result_m = ktc.onnx_optimizer.torch_exported_onnx_flow(exported_m)
onnx.save(result_m,'/workspace/last_kneron.onnx')


onnx_path = '/workspace/last_kneron.onnx'
m = onnx.load(onnx_path)
m = ktc.onnx_optimizer.torch_exported_onnx_flow(m)
onnx.save(m,'/workspace/last_optimized.onnx')

# npu (only) performance simulation
km = ktc.ModelConfig(20008, "0001", "630", onnx_model=m)
eval_result = km.evaluate()
print("\nNpu performance evaluation result:\n" + str(eval_result))

img_list = []
for (dirpath, dirnames, filenames) in walk("24060311/images"):
    for f in filenames:
        fullpath = os.path.join(dirpath, f)
        
        image = Image.open(fullpath)
        image = image.convert("RGB")
        image = Image.fromarray(np.array(image)[...,::-1])
        img_data = np.array(image.resize((640, 640), Image.BILINEAR)) / 255
        img_data = img_data.transpose(2, 0 ,1)[None]
        print(fullpath)
        img_list.append(img_data)

# fixed-point analysis
bie_model_path = km.analysis({"images": img_list})
print("\nFixed-point analysis done. Saved bie model to '" + str(bie_model_path) + "'")

# compile
nef_model_path = ktc.compile([km])
print("\nCompile done. Saved Nef file to '" + str(nef_model_path) + "'")
